/** INF100, ving 7, oppgave 5.1
 *  En klasse som representerer en varekatalog.
 */
      
public class Varekatalog {

    /** Antall varer */
    private int antall;

    /** Tabell med varer */
    private Vare[] varer;


    /**
       Konstruktr som oppretter plass til angitt antall varer
       @param n Antall varer det skal opprettes plass til
    */
    public Varekatalog(int n) {
        if (n>0)
            varer = new Vare[n];
        antall = 0;
    }

    /** @return Antall varer */
    public int hentAntall() {
        return antall;
    }

    /** @return Maksimalt antall varer */
    public int hentMaksAntall() {
        return varer.length;
    }

    /** @return true hvis katalogen er full, false ellers */
    public boolean full() {
        return (hentAntall() >= hentMaksAntall());
    }

    /** Setter inn en gitt vare
    * @param vare Varen som skal settes inn
    * @return true hvis innsetting gikk bra, false ellers */
    public boolean settInn(Vare vare) {
        if (!full() && vare != null) {
            varer[antall++] = vare;
            return true;
        }
        else
            return false;
    }

    /** Finner vare med gitt navn
    * @param navn Varens navn
    * @return Referanse til frst innsatte vare med dette navnet, null hvis varen ikke ble funnet */
    public Vare finn(String navn) {
        for (int i=0; i<hentAntall(); ++i)
            if (varer[i].hentNavn().equals(navn))
                return varer[i];
        return null;
    }

}
