/** INF100, ving 7, oppgave 5.2
 *  Et program som bruker en varekatalog.
 */
     
public class Vareklient {

    private static Varekatalog katalog;

    public static void main(String[] args) {
        System.out.println();
        System.out.println("Dette programmet holder orden p varer som du kan legge inn.");
        System.out.println();
        System.out.print("Hvor mange varer vil du maksimalt legge inn? ");
        int maxVarer = Terminal.lesInt();
        katalog = new Varekatalog(maxVarer);

        int valg = 0;
        while (valg != 3) {
            valg = meny();
            switch(valg) {
                case 1:
                    settInn();
                    break;
                case 2:
                    skriv();
                    break;
                case 3:
                    avslutt();
                    break;
                default:
                    feil();
            }
        }
    }

    private static int meny() {
        System.out.println();
        System.out.println("Mulige valg:");
        System.out.println("\t1: Sette inn en ny vare");
        System.out.println("\t2: F skrevet ut informasjon om en vare");
        System.out.println("\t3: Avslutte programmet");
        System.out.print("\tDitt valg: ");
        return Terminal.lesInt();
    }

    private static void settInn() {
        System.out.print("\t\tVarenavn: ");
        String navn = Terminal.lesString();
        System.out.print("\t\tPris: ");
        double pris = Terminal.lesDouble();
	Vare nyVare = new Vare(navn,pris);
        nyVare.settMoms(bekreft("Er denne varen momsplagt?"));
        if (!katalog.settInn(nyVare))
            System.out.println("\t\tKunne dessverre ikke sette inn denne varen.");
   }

    private static void skriv() {
        System.out.print("\t\tVarenavn: ");
        String navn = Terminal.lesString();
        Vare vare = katalog.finn(navn);
        if (vare == null)
            System.out.println("\t\tDenne varen er ikke registrert i katalogen.");
        else
            System.out.println("\t\tUtsalgsprisen p denne varen er " + vare.hentUtsalgspris());
    }

    private static void avslutt() {
        System.out.println("Programmet avsluttes.");
    }

    private static void feil() {
        System.out.println("Ugyldig valg.");
    }

    /** Ber brukeren svare j eller n p et sprsml
     *  og leser inn svaret fra terminalen.
     *  @param tekst Sprsmlsteksten
     *  @return true hvis j, false hvis n
     */
    static boolean bekreft(String tekst) {
	String svar;
	System.out.print(tekst + " (j/n) ");
	svar = Terminal.lesString().toLowerCase();
	while (!(svar.equals("j") || svar.equals("n"))) {
	    System.out.print("Svar j eller n: ");
	    svar = Terminal.lesString();
	}
	return (svar.equals("j"));
    }
}
